"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _terraList = _interopRequireWildcard(require("terra-list"));
var _excluded = ["children"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _callSuper(t, o, e) { return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
var propTypes = {
  /**
   * Menu.Items to be grouped together.
   */
  children: _propTypes.default.node.isRequired,
  /**
   * Callback function called when selected index changes.
   */
  onChange: _propTypes.default.func
};
var childContextTypes = {
  isGroupItem: _propTypes.default.bool,
  shouldReserveSpaceForIcon: _propTypes.default.bool
};
var initialSingleToggledIndex = function initialSingleToggledIndex(children) {
  var childArray = _react.default.Children.toArray(children);
  for (var i = 0; i < childArray.length; i += 1) {
    if (childArray[i].props.isSelected || childArray[i].props.isToggled) {
      return i;
    }
  }
  return -1;
};
var MenuItemGroup = /*#__PURE__*/function (_React$Component) {
  function MenuItemGroup(props) {
    var _this;
    (0, _classCallCheck2.default)(this, MenuItemGroup);
    _this = _callSuper(this, MenuItemGroup, [props]);
    _this.cloneChildren = _this.cloneChildren.bind(_this);
    _this.handleItemToggled = _this.handleItemToggled.bind(_this);
    _this.state = {
      toggledIndex: initialSingleToggledIndex(props.children)
    };
    return _this;
  }
  (0, _inherits2.default)(MenuItemGroup, _React$Component);
  return (0, _createClass2.default)(MenuItemGroup, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        isGroupItem: true,
        shouldReserveSpaceForIcon: true
      };
    }
  }, {
    key: "handleItemToggled",
    value: function handleItemToggled(event, metaData) {
      if (this.state.toggledIndex !== metaData.index && !metaData.isDisabled) {
        event.preventDefault();
        this.setState({
          toggledIndex: metaData.index
        });
        if (this.props.onChange) {
          this.props.onChange(event, metaData.index);
        }
      }
    }
  }, {
    key: "cloneChildren",
    value: function cloneChildren(children) {
      var _this2 = this;
      return _react.default.Children.map(children, function (child, index) {
        var isToggleable = true;
        if (child.props.isToggleable === false && child.props.isSelectable === false) {
          isToggleable = false;
        }
        return /*#__PURE__*/_react.default.cloneElement(child, {
          isToggleable: isToggleable,
          isToggled: _this2.state.toggledIndex === index,
          onClick: _terraList.Utils.wrappedOnClickForItem(child.props.onClick, _this2.handleItemToggled, {
            index: index,
            isDisabled: child.props.isDisabled
          }),
          onKeyDown: _terraList.Utils.wrappedOnKeyDownForItem(child.props.onKeyDown, _this2.handleItemToggled, {
            index: index,
            isDisabled: child.props.isDisabled
          })
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        customProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var managedChildren = this.cloneChildren(children);
      return /*#__PURE__*/_react.default.createElement(_terraList.default, (0, _extends2.default)({}, customProps, {
        role: "group"
      }), managedChildren);
    }
  }]);
}(_react.default.Component);
MenuItemGroup.propTypes = propTypes;
MenuItemGroup.childContextTypes = childContextTypes;
var _default = exports.default = MenuItemGroup;