"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var isFullScreen = function isFullScreen(isHeightBounded, isWidthBounded, boundingFrame, popupWidth) {
  var width = popupWidth;
  var maxWidth;
  if (boundingFrame && !isWidthBounded) {
    maxWidth = boundingFrame.clientWidth;
  } else {
    maxWidth = window.innerWidth;
  }
  if (maxWidth <= 0) {
    return false;
  }
  return isHeightBounded && (width >= maxWidth || isWidthBounded);
};
var isMac = function isMac() {
  return navigator.userAgent.indexOf('Mac') !== -1 && navigator.userAgent.indexOf('Win') === -1;
};
var totalItems = function totalItems(children) {
  var count = 0;
  _react.default.Children.map(children, function (item) {
    if (item.props.text) {
      count += 1;
    } else if (item.props.children) {
      _react.default.Children.forEach(item.props.children, function () {
        count += 1;
      });
    }
  });
  return count;
};
var findMenuItem = function findMenuItem(updatedStack, key) {
  for (var i = 0; i < updatedStack.length; i += 1) {
    if (updatedStack[i].key === key) {
      return updatedStack[i];
    }
    if (updatedStack[i].props.subMenuItems) {
      return findMenuItem(updatedStack[i].props.subMenuItems, key);
    }
  }
  return undefined;
};

/**
 * Util to determine if the user agent indicates that the browser is Safari
 * @return {boolean}
 */
var isSafari = function isSafari() {
  return navigator.userAgent.indexOf('Safari') !== -1 && navigator.userAgent.indexOf('Chrome') === -1;
};
var MenuUtils = {
  isFullScreen: isFullScreen,
  isMac: isMac,
  totalItems: totalItems,
  findMenuItem: findMenuItem,
  isSafari: isSafari
};
var _default = exports.default = MenuUtils;